var Schema = require('mongoose').Schema;

var schemaOptions = { safe: true };

var schema = new Schema({
	name: { type: String, trim: true },
	_people: [ { type: Schema.Types.ObjectId, ref: 'Person' } ],
	billing:  {
		cards: 		[ { id: String, service: String } ],
		_admins: 	[ { type: Schema.Types.ObjectId, ref: 'Person' } ]
	},
	products: [ String ],
	times: {
		created: { type: Date, default: Date.now },
		deactivated: Date
	},
	active: {type: Boolean, default: true}
}, schemaOptions);


exports.schema = schema;
//module.exports = schema;