var _ =    			require('underscore'),
    AWS =           require('aws-sdk'),
    models =        require ('mongoose').models,    
    utilities =     require('../../utilities'),
    csd =           {},
    config =        {};


//// Public ---------------------------------------------------------------------------------------

module.exports.init = function (options) {
    utilities.logger.info('framework/search/bin/awscs init');
    if (options) _.extend (config, options);
    
    _.each (config.domains, function (domain, domainName) {
    	if (domain.enabled) {
            
            csd['doc-' + domainName] = new AWS.CloudSearchDomain ( _.extend(
                _.pick (domain, "apiVersion", "region", "sslEnabled"),
                { endpoint: domain.docEndpoint },
                config.options
            ));

            csd['search-' + domainName] = new AWS.CloudSearchDomain ( _.extend(
                _.pick (domain, "apiVersion", "region", "sslEnabled"),
                { endpoint: domain.searchEndpoint },
                config.options
            ));
        }
    });
};

module.exports.uploadDocuments = function (data, callback) {
    utilities.logger.info('framework/search/bin/awscs uploadDocuments');
	csd['doc-' + data.domainName].uploadDocuments(data.params, function(e, result) {
		if (e) { utilities.logger.error(e); return callback ( new utilities.error.aws (e.code) ); }
        return callback ( null, result );
	});
};


module.exports.search = function (data, callback) {
    utilities.logger.info('framework/search/bin/awscs search');
    csd['search-' + data.domainName].search(data.params, function(e, results) {
        if (e) { utilities.logger.error(e); return callback ( new utilities.error.aws (e.code) ); }
        if (results.hits.found > 0) return callback ( null, _.pluck (results.hits.hit, 'fields'));
        else return callback (null, []);
    });
};
