var http            =   require('http'),
    _               =   require ('underscore');

function requestHTTP (options, data, callback) {
    var defaults = { 
        host: 'localhost', 
        port: 12080, 
        path: '', 
        method: 'POST',
        headers: { 'Content-Type': 'application/json' }
    }; 

    _.extend ( defaults, options );
    
    var req = http.request(defaults, function(res) {
        var resData = ''
        var cookieData = '';
        if (res.headers['set-cookie']) cookieData = res.headers['set-cookie'][0];
        //console.log('STATUS: ' + res.statusCode);
        //console.log('HEADERS: ' + JSON.stringify(res.headers));
        res.setEncoding('utf8');
        res.on('data',  function (chunk)    { resData += chunk; });
        res.on('end',   function ()         { callback ( null, resData, cookieData ); });

    });

    //req.setHeader("Content-Type", "application/json");
    req.on('error', function(e) { callback (e); });

    // write data to request body if not GET
    if ( defaults.method !== 'GET' ) req.write ( JSON.stringify(data) );
    req.end();
}

exports.request = function (path, method, headers, data, callback) {
    var options = { path: path, method: method, headers: headers }, httpData = {};
    
    if ( method !== 'POST') {
        options.path += '?';
        _.each (data, function (value, key) { options.path += key + '=' + value + '&'; });
        options.path = options.path.slice(0,options.path.length-1) //remove last character
    } else httpData = data;

    requestHTTP (options, httpData, callback);
}

